require 'framework/tokenstring'

require 'plugins/lexers/rubylexer'


module Mondrian

    class RubyString < TokenString
        use_lexer RubyLexer
            
        protected
        def get_context(index)
            return RubyContext.new if index == 0
        
            i = @tokens.rindex(@encoder.match_any, index - 1)
            
            last = i ? @text[i, $&.length] : nil
            last_token = last ? @encoder.token_symbol($&) : nil
            
            if last and last_token != :whitespace #FIXME - need to exclude comments also
                last_black = last
                last_black_token = last_token
            else
                i = @tokens.rindex(@encoder.not_whitespace, index - 1)

                last_black = i ? @text[i, $&.length] : nil
                last_black_token = i ? @encoder.token_symbol($&) : nil
            end
            
            RubyContext.new(last, last_token, last_black, last_black_token)
        end


        protected
        def get_lex_start(index)
            return 0 if index == 0

            lex_start = @tokens.rindex(@encoder.not_whitespace, index - 1)
                
            while lex_start and @tokens.rindex(@encoder.not_whitespace, lex_start - 1) == lex_start - ($& ? $&.length : 0)
                lex_start -= $&.length
            end
                
            lex_start or 0
        end

    end

end
